#include "stdio.h"
#include "malloc.h"
#include "stdlib.h"

#define TRUE  1
#define FALSE 0
#define OK 1
#define ERROR 0
#define INFEASIBLE -1
#define OVERFLOW  -2
typedef int  Status;


//顺序表静态存储结构的定义
#define LIST_INIT_SIZE 100
#define LISTINCREMENT 10
typedef int ElemType;
typedef struct{
    ElemType *elem;
    int length;
    int listsize;
}SqList;

//顺序表的初始化

Status InitList_Sq(SqList &L)
{
    L.elem=(ElemType*)malloc(LIST_INIT_SIZE*sizeof(ElemType));
    if(!L.elem)
        exit(OVERFLOW);
    L.length=0;
    L.listsize=LIST_INIT_SIZE;
    return OK;
}
//按位置查找操作
void GetElem(SqList L,int i,ElemType &e)
{
    if(i<1||i>L.length)
        exit(OVERFLOW);
    e=*(L.elem+i-1);

}




//按内容查找操作
int LocateElem_Sq(SqList L,ElemType e)
{
    ElemType *p=L.elem;
    int i=1;
    while((*p!=e)&&i<=L.length)
    {
        p++;
        i++;
    }
    if(*p==e)
        return i;
    else
        return 0;
}



//插入操作
Status ListInsert_Sq(SqList &L,int i,ElemType e)
{
    if(i<1||i>L.length+1)
        return ERROR;
    if(L.length>=L.listsize)
    {
        ElemType *newbase=(ElemType *)realloc(L.elem,(L.listsize+LISTINCREMENT)*sizeof (ElemType));
        if(!newbase)
            exit(OVERFLOW);
        L.elem=newbase;
        L.listsize+=LISTINCREMENT;
    }
    ElemType *p=L.elem+L.length-1;
    ElemType *q=L.elem+i-1;
    for( ;p>=q;p--)
        *(p+1)=*p;
    *q=e;
    L.length++;
    return OK;
}



//删除操作
Status ListDelete_Sq(SqList &L,int i,ElemType &e)
{
    if(i<1||i>L.length)
        return ERROR;
    ElemType *p=L.elem+i-1;
    ElemType *q=L.elem+L.length-1;
    e=*p;
    for(p=p+1;p<=q;p=p+1)
        *(p-1)=*p;
    L.length--;
    return OK;
}

int main()
{
   SqList SL;
   InitList_Sq(SL);
   ListInsert_Sq(SL,1,11);
   ListInsert_Sq(SL,2,12);
   ListInsert_Sq(SL,3,13);
   ListInsert_Sq(SL,4,14);
   ListInsert_Sq(SL,5,15);
   ElemType shanchu;
   ListDelete_Sq(SL,2,shanchu);
   printf("删除的第二个位置的元素为：%d",shanchu);






}
